unit uPlugin;

interface

uses Graphics, Windows, Classes, SysUtils, Dialogs, Messages, uFunc,
     Variants,  Controls, Forms, uStickyForm,
     StdCtrls, ComCtrls, Unit1, inifiles;

function  PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer; cdecl; stdcall;
procedure PluginStop(); cdecl; stdcall;
procedure PluginShowOptions(); cdecl; stdcall;
procedure PluginShowAbout(); cdecl; stdcall;
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD); cdecl; stdcall;
function  PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar;
            dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; cdecl; stdcall;
function CallWndProcHookProc(CODE, WParam, LParam: DWORD): DWORD; stdcall;


procedure ppUserChangeChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
procedure ppUserEnterChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
procedure ppUserLeaveChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);

function GetChatPanelSize() : TSize;
procedure FixWindowPos(AForm : TfrmStickyForm);
function Save:string;
procedure getchans;
procedure reenter;

var
  CommFort_Adress:string;
  path:String;

exports PluginStart, reenter, PluginStop, Save, PluginProcess, PluginGetData, PluginShowOptions, PluginShowAbout;

implementation

var
  ChatWindow : HWND = 0; //  
  ChannelsPanel : HWND = 0; //     
  CallWndProcHookHandle : HHOOK = 0;
  ChatWindowHeight : integer;
  frmStickyForm : TfrmStickyForm = nil;
  StickyChanName :String;
  Ini: Tinifile;


//---------------------------------------------------------------------------

function KillDir (Dir: AnsiString): boolean;
var
  Sr: SysUtils.TSearchRec;
begin
{$I-}
  if (Dir <> '') and (Dir[length(Dir)] = '\') then
    Delete(Dir, length(dir), 1);
  if FindFirst(Dir + '\*.*', faDirectory + faHidden + faSysFile +
    faReadonly + faArchive, Sr) = 0 then
    repeat
      if (Sr.Name = '.') or (Sr.Name = '..') then
        continue;
      if (Sr.Attr and faDirectory <> faDirectory) then
   begin
if AnsiLowerCase(ExtractFileExt(sr.Name)) = '.tmp' then
 begin
        FileSetReadOnly(Dir + '\' + sr.Name, False);
        DeleteFile(Dir + '\' + sr.Name);
 end
   end
      else
        KillDir(Dir + '\' + sr.Name);
    until FindNext(sr) <> 0;
  FindClose(sr);
//  RemoveDir(Dir); //   
  KillDir := (FileGetAttr(Dir) = -1);
end;

function Save:string;
var
  Ini: Tinifile;
begin
  Ini:=TiniFile.Create(path+'IPTV_Plug.ini');
  Ini.WriteString('Setings','VideoLan VLC Dll', Form1.sDirectoryEdit1.text);
  Ini.WriteString('Setings','Chann IPTV Plug', Form1.sComboBox1.text);
  Ini.Free;
end;

function open:string;
var
 ini: TIniFile;
begin
  Ini:=TiniFile.Create(path+'IPTV_Plug.ini');
  Form1.sDirectoryEdit1.text:=Ini.ReadString('Setings', 'VideoLan VLC Dll',ExtractFileDir(ParamStr(0))+'\Plugins\VLC');
  Form1.sComboBox1.text:=Ini.ReadString('Setings', 'Chann IPTV Plug','IP-TV');
  Ini.Free;
end;

function PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer;
var
iSize, iReadOffset : Integer;
aDataToSend, aData : AnsiString;
begin
	dwPluginID := dwThisPluginID;
	CommFortProcess := func1;
	CommFortGetData := func2;
  ChatWindow := FindWindow('TfChatClient', nil);
  ChannelsPanel  := FindWindowEx(ChatWindow, 0, 'TPanel', nil);
  if CallWndProcHookHandle = 0 then
    CallWndProcHookHandle := SetWindowsHookEx(WH_CALLWNDPROC, @CallWndProcHookProc, HInstance, GetCurrentThreadId())
  else
    begin
      Result := Integer(False);
      Exit;
    end;

	Result := Integer(TRUE);

  //   
  iSize := CommFortGetData(dwPluginID, 2010, nil, 0, nil, 0); //  
	SetLength(aData, iSize);
	CommFortGetData(dwPluginID, 2010, PAnsiChar(aData), iSize, nil, 0);// 
	iReadOffset := 0;
	path := fReadText(PAnsiChar(aData), iReadOffset);

  // 
  iSize := CommFortGetData(dwPluginID, 10, nil, 0, nil, 0); //  
	SetLength(aData, iSize);
	CommFortGetData(dwPluginID, 10, PAnsiChar(aData), iSize, nil, 0);// 
	iReadOffset := 0;
	CommFort_Adress := fReadText(PAnsiChar(aData), iReadOffset);



  form1 := TForm1.Create(Application);

    frmStickyForm := TfrmStickyForm.Create(nil);
     open;
     reenter;
    StickyChanName := Form1.sComboBox1.Text;
  //   
//  frmStickyForm.ClientSocket1.Host := CommFort_Adress;
//  frmStickyForm.ClientSocket1.Active := True;
    frmStickyForm.Play_List_IPTV;



end;

procedure reenter;
var
tmpb:Boolean;
tmpi:integer;
ChatPanelSize : TSize;
begin

        if StickyChanName<>Form1.sComboBox1.Text then begin
         StickyChanName:=Form1.sComboBox1.Text;
          if Assigned(frmStickyForm) then
      begin

         ChatPanelSize := GetChatPanelSize();
       if (CallWndProcHookHandle <> 0) and (Integer(UnhookWindowsHookEx(CallWndProcHookHandle)) <> 0) then
   CallWndProcHookHandle := 0;
       MoveWindow(frmStickyForm.ParentChanHandle, 0, 0, ChatPanelSize.cx, ChatPanelSize.cy, True);
        FreeAndNil(frmStickyForm);

        ChatWindow := 0;
    ChannelsPanel := 0;
        end;
    if (not Assigned(frmStickyForm)) then
      begin
              ChatWindow := FindWindow('TfChatClient', nil);
  ChannelsPanel  := FindWindowEx(ChatWindow, 0, 'TPanel', nil);
  if CallWndProcHookHandle = 0 then
    CallWndProcHookHandle := SetWindowsHookEx(WH_CALLWNDPROC, @CallWndProcHookProc, HInstance, GetCurrentThreadId());

        frmStickyForm := TfrmStickyForm.Create(nil);
        frmStickyForm.ParentChanName := StickyChanName;
        frmStickyForm.ParentWindow := ChannelsPanel;
        frmStickyForm.ParentChanHandle := 0;
        ppUserChangeChannel(nil, 0);
        FixWindowPos(frmStickyForm);
        end;
      end;

end;

procedure getchans;
var
aDataToSend, aData : AnsiString;
iSize, iReadOffset : Integer;
c,g,i:integer;
kan,tema:string;
begin
iSize := CommFortGetData(dwPluginID, 15, nil, 0, nil, 0); //  
	SetLength(aData, iSize);
	CommFortGetData(dwPluginID, 15, PAnsiChar(aData), iSize, nil, 0);// 
	iReadOffset := 0;
  g := fReadinteger(PAnsiChar(aData), iReadOffset);

  if g>0 then begin
    form1.sComboBox1.Items.clear;

  for c := 1 to g do begin
   kan := fReadText(PAnsiChar(aData), iReadOffset);
   tema := fReadText(PAnsiChar(aData), iReadOffset);
   form1.sComboBox1.Items.Add(kan);
  end;
  for I := 0 to form1.sComboBox1.Items.count-1 do
  if form1.sComboBox1.Items[i]=StickyChanName then
  form1.sComboBox1.itemindex:=i;

  end;
end;
//-----

//---------------------------------------------------------------------------
procedure PluginStop();
var
    ChatPanelSize : TSize;
begin

   Save;

  try
    if (CallWndProcHookHandle <> 0) and (Integer(UnhookWindowsHookEx(CallWndProcHookHandle)) <> 0) then
      CallWndProcHookHandle := 0;
    if Assigned(frmStickyForm) then
      begin
        ChatPanelSize := GetChatPanelSize();
        MoveWindow(frmStickyForm.ParentChanHandle, 0, 0, ChatPanelSize.cx, ChatPanelSize.cy, True);
        FreeAndNil(frmStickyForm);
      end;
    ChatWindow := 0;
    ChannelsPanel := 0;
  except
    on E : Exception do
      ShowMessage('PluginStop() ' + E.Message);
  end;

end;


//---------------------------------------------------------------------------
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset: Integer;

begin
  iReadOffset := 0;
  case dwID of
    9  : ppUserChangeChannel(bInBuffer, dwInBufferSize);
    30 : ppUserEnterChannel(bInBuffer, dwInBufferSize);
    31 : ppUserLeaveChannel(bInBuffer, dwInBufferSize);
  end;
end;
//---------------------------------------------------------------------------
function PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;
var iWriteOffset, iSize: Integer;
    uName: WideString;
begin
	iWriteOffset := 0;
	if (dwID = 2800) then // 
	begin
		if (dwOutBufferSize = 0) then
			Result := 4 //   ,    
		else
		begin
			fWriteInteger(bOutBuffer, iWriteOffset, 2); //    
			Result := 4;//    
		end;
	end
	else
	if (dwID = 2810) then //  (  )
	begin
		uName := 'IPTV Plugin';// 
		iSize := Length(uName) * 2 + 4;

		if (dwOutBufferSize = 0) then
			Result := iSize //   ,    
		else
		begin
			fWriteText(bOutBuffer, iWriteOffset, uName);
			Result := iSize;//    
		end;
	end
	else
		Result := 0;//  -   
end;


//---------------------------------------------------------------------------
procedure PluginShowOptions();
begin
  Form1.show;
  Form1.sPageControl1.ActivePageIndex := 0;
end;

//---------------------------------------------------------------------------
procedure PluginShowAbout();
begin
 Form1.show;
 Form1.sPageControl1.ActivePageIndex := 1;
end;

//--------------------------------------------------------------------------------------------------
function CallWndProcHookProc(CODE, WParam, LParam: DWORD): DWORD; stdcall;
var _CwpStruct : ^TCWPStruct;
begin
  try
    _CwpStruct := Pointer(LParam);
    case _CwpStruct.message of
      WM_SIZE :
        begin
          if Assigned(frmStickyForm) and (frmStickyForm.ParentChanHandle = _CwpStruct.hwnd) then
            FixWindowPos(frmStickyForm);
        end;
    end;
  finally
    Result := CallNextHookEx(CallWndProcHookHandle, code, WParam, LParam);
  end;
end;


procedure ppUserChangeChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset : Integer;
    CurrentChannelName : WideString;
    CurrentChannelHandle : HWND;
begin
  iReadOffset := 0;
  if Assigned(bInBuffer) then
    CurrentChannelName := fReadText(bInBuffer, iReadOffset)
  else
    CurrentChannelName := GetCurrentChannelName();
  if Assigned(frmStickyForm) then
    begin
      if (frmStickyForm.ParentChanName = CurrentChannelName) then
        begin
          if frmStickyForm.ParentChanHandle = 0 then
            begin
              CurrentChannelHandle := FindWindowEx(ChannelsPanel, 0, 'TRichView', nil);
              while not(IsWindowVisible(CurrentChannelHandle)) and (CurrentChannelHandle <> 0) do
                begin
                  CurrentChannelHandle := FindWindowEx(ChannelsPanel, CurrentChannelHandle, 'TRichView', nil);
                end;
              frmStickyForm.ParentChanHandle := CurrentChannelHandle;
            end;
          if frmStickyForm.ParentChanHandle <> 0 then
            frmStickyForm.Show();
          FixWindowPos(frmStickyForm);
        end
      else
        frmStickyForm.Hide();
    end;
end;

procedure ppUserEnterChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset : Integer;
    ChanName : WideString;
begin
  try
    iReadOffset := 0;
    ChanName := fReadText(bInBuffer, iReadOffset);
    if ChanName = StickyChanName then
      begin

        frmStickyForm.ParentChanName := ChanName;
        frmStickyForm.ParentWindow := ChannelsPanel;
        frmStickyForm.ParentChanHandle := 0;
        ppUserChangeChannel(nil, 0);
        FixWindowPos(frmStickyForm);

      end;
  except
    on E: Exception do
      ShowMessage('ppUserEnterChannel() ' + E.Message);
  end;
end;

procedure ppUserLeaveChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset : Integer;

    ChanName : WideString;
begin
  iReadOffset := 0;
  if Assigned(frmStickyForm) then
    begin
      ChanName := fReadText(bInBuffer, iReadOffset);
      if ChanName = StickyChanName then
      begin
        frmStickyForm.PasLibVlcPlayer1.Stop;
        FreeAndNil(frmStickyForm);
      end;

    end;
end;

function GetChatPanelSize() : TSize;
var WindowRect : TRect;
begin
  if GetWindowRect(ChannelsPanel, WindowRect) then
    begin
      Result.cx := WindowRect.Right - WindowRect.Left;
      Result.cy := WindowRect.Bottom - WindowRect.Top;
    end
  else
    begin
      Result.cx := 0;
      Result.cy := 0;
    end;

end;

procedure FixWindowPos(AForm : TfrmStickyForm);
var ChatPanelSize : TSize;
begin
  if AForm.ParentChanHandle = 0 then
    Exit;
  ChatPanelSize := GetChatPanelSize();
  AForm.Height := ChatPanelSize.cy;
  AForm.Width := ChatPanelSize.cx;
  MoveWindow(AForm.ParentChanHandle, 0, AForm.Height, AForm.Width, ChatPanelSize.cy - AForm.Height, True);
end;


end.

